---
features:
  primary:
  - name: "Workspaces available in Beta for public projects"
    available_in: [premium, ultimate]  
    gitlab_com: true
    documentation_link: 'https://docs.gitlab.com/ee/user/workspace/index.html'
    video: https://www.youtube-nocookie.com/embed/yjweL075Cdo
    reporter: ericschurter
    stage: create 
    categories:
      - 'Workspaces'
    epic_url: 'https://gitlab.com/groups/gitlab-org/-/epics/10122'
    description: |
      Stop spending hours, or even days, troubleshooting your local development environment and interpreting inscrutable package installation errors. Now you can define a consistent, stable, and secure development environment in code and use it to create on-demand; all inside Workspaces. 

      Workspaces serve as personal, ephemeral development environments in the cloud. By eliminating the need for a local development environment, you can focus more on your code and less on your dependencies. Accelerate the process of onboarding to a new project and get up and running in minutes instead of days. 

      After the GitLab Agent for Kubernetes is configured and [the dependencies are installed](https://docs.gitlab.com/ee/user/workspace/#prerequisites) in your self-hosted cluster or cloud platform of choice, you can define your development environment in a `.devfile.yaml` file and store it in a public project. Then, you and any other developers with access to the agent can create a workspace based on the `.devfile.yaml` file and edit directly in the embedded Web IDE. You'll have full terminal access to the container, allowing you to work more efficiently. When you're done, or if something goes wrong, you can shut down the workspace and start a fresh, new workspace for your next development task.  

      This short video walks you through the lifecycle of a workspace in the current Beta. Learn more about workspaces in the [documentation](https://docs.gitlab.com/ee/user/workspace/index.html) and let us know what you think in the [feedback issue](https://gitlab.com/gitlab-org/gitlab/-/issues/410031). 
